import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import mac.types.steeringTypes.*;

public class DoInvoke implements ActionListener {

  String host;
  int port;
  Socket s;
  ObjectOutputStream actionOut;

  JButton connect, invoke;

  ActionCall testCall;

  public DoInvoke( String address ) {

    host = address.substring( 0,address.lastIndexOf(":") ); 
    port = Integer.parseInt( address.substring(address.lastIndexOf(":")+1, 
					       address.length()) );

    testCall = new ActionCall( "compensate", new int[0] );
  }

  public static void main( String[] argv ) {
    DoInvoke doSend =  new DoInvoke( argv[0] );

    JFrame root = new JFrame( "test action" );
    Box buttons = Box.createHorizontalBox();
    doSend.connect = new JButton( "Connect" );
    buttons.add( doSend.connect );
    doSend.connect.addActionListener( doSend );
    doSend.invoke = new JButton( "Invoke Action" );
    buttons.add( doSend.invoke );
    doSend.invoke.addActionListener( doSend );
    JButton exit = new JButton( "Exit" );
    buttons.add( exit );
    exit.addActionListener( new ActionListener() {
	public void actionPerformed( ActionEvent e ) {
	  System.exit( 0 );
	}
      } );
    root.getContentPane().add( buttons );
    root.pack();
    root.setVisible( true );
  }

  public void actionPerformed( ActionEvent act ) {
    if( act.getSource() == connect ) 
      // try to establish connection
      try {
	s = new Socket(host,port);
	OutputStream sout =  s.getOutputStream();
	System.out.println("Connected to " + s.getInetAddress() +
			   ":" + s.getPort());
	actionOut = new ObjectOutputStream( sout );
      } catch( IOException e ) {
	try{  
	  actionOut.close(); 
	  s.close(); 
	} catch( IOException e2 ) { }
	System.err.println( "Conection to injector failed: " + e );
	System.exit( 1 );
      }
    else if( act.getSource() == invoke ) 
      try {
	actionOut.writeObject( testCall );
      } catch( IOException e ) {
	System.err.println( "error sending action: " + e );
      }
  }
}
